<?php

namespace Teknisa\FIN\Modules\MovimentacaoBancaria\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;

class Bco21200RelacaoSaldosContaCorrenteFactory { 
  
  protected $connection;
  protected $nrOrg;

  public function __construct(EntityManager $entityManager, Environment $environment) {
    $this->connection = $entityManager->getConnection();
    $this->nrOrg = $environment->getNrOrg();
  }
  
  // Retorna um array em que o saldo de cada conta corrente
  // está localizado no índice igual ao seu cdreducont.
  public function findSaldos($codigos, $data) {
    $params = array(
        'CODIGOS' => $codigos,
        'DATA' => $data,
        'NRORG' => $this->nrOrg
      );
    $sql = "SELECT CDREDUCONT, VRSDOCCORR FROM SDOCCORR WHERE
 INSTR(:CODIGOS, CDREDUCONT) <> 0 AND
 DTSDOCCORR = (SELECT MAX(DTSDOCCORR) FROM SDOCCORR WHERE
              INSTR(:CODIGOS, CDREDUCONT) <> 0 AND
              DTSDOCCORR <= TO_DATE(:DATA) AND
              NRORG = :NRORG)";
              
    $std = $this->connection->prepare($sql);
    
    $std->execute($params);
    
    $result = $std->fetchAll();
    $arraySaldos = array();
    
    foreach($result as $row) {
      $arraySaldos[$row['CDREDUCONT']] = $row['VRSDOCCORR'];
    }
    
    return $arraySaldos;
  }
}